### A free/open-source library for quantitative finance

Public Member Functions | Protected Attributes
GenericEngine< ArgumentsType, ResultsType > Class Template Reference

template base class for option pricing engines More...

`#include <ql/pricingengine.hpp>`

Inheritance diagram for GenericEngine< ArgumentsType, ResultsType >:
[legend]

List of all members.

## Public Member Functions

PricingEngine::arguments * | getArguments () const
const PricingEngine::results * | getResults () const
void | reset ()
void | update ()

## Protected Attributes

ArgumentsType | arguments_
ResultsType | results_

## Detailed Description

### template<class ArgumentsType, class ResultsType>
class QuantLib::GenericEngine< ArgumentsType, ResultsType >

template base class for option pricing engines

Derived engines only need to implement the `calculate()` method.

## Member Function Documentation

void update | ( |  | ) | `[virtual]`

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Implements Observer.

Reimplemented in AnalyticHestonHullWhiteEngine, FdHestonHullWhiteVanillaEngine, FdHestonVanillaEngine, LatticeShortRateModelEngine< Arguments, Results >, LatticeShortRateModelEngine< CapFloor::arguments, CapFloor::results >, LatticeShortRateModelEngine< VanillaSwap::arguments, VanillaSwap::results >, LatticeShortRateModelEngine< Swaption::arguments, Swaption::results >, and LatticeShortRateModelEngine< CallableBond::arguments, CallableBond::results >.